#include "RingBuffer.h"


struct SRingBuffer {
  size_t len;
  size_t start;
  size_t end;
  
  sbyte * array;
}


SRingBuffer *
s_ring_buffer_new (size_t len) {
  SRingBuffer * self = malloc (sizeof (SRingBuffer));
  self->array = calloc (len, size_t (sbyte));
  
  self->len = len;
  self->start = 0;
  self->end = 0;
  
  return self;
}


void
s_ring_buffer_free (SRingBuffer * self) {
  free (self->array);
  free (self);
}

sboolean
s_ring_buffer_is_empty (SRingBuffer * self) {
  return (self->start == self->end);
}

void
s_ring_buffer_push (SRingBuffer * self,
                    sbyte data);


void
s_ring_buffer_push_back (SRingBuffer * self,
                         sbyte data);


sbyte
s_ring_buffer_pop (SRingBuffer * self);


sbyte
s_ring_buffer_pop_back (SRingBuffer * self);


void
s_ring_buffer_realloc (SRingBuffer * self,
                       size_t len);


size_t
s_ring_buffer_len (SRingBuffer * self);


size_t
s_ring_buffer_size (SRingBuffer * self);


void
s_ring_buffer_for_each (SRingBuffer * self,
                        ForEachFunc func,
                        spointer user_data);

